<script>
import { calculatorMixin } from '../../mixins';
import StepProgress from '~/components/common/step-progress-bar.vue';
import TimeResults from '@/components/calculator/time-results.vue';
import Input from '@/components/calculator/input.vue';

export default {
  name: 'TimeROICalculator',
  components: {
    StepProgress,
    TimeResults,
    Input,
  },
  mixins: [calculatorMixin],
  props: {
    timeData: {
      type: Object,
      required: true,
      default: null,
    },
    timeResultsData: {
      type: Object,
      required: true,
      default: null,
    },
    tooltipData: {
      type: Object,
      required: true,
      default: null,
    },
    premiumFeatures: {
      type: Object,
      required: false,
      default: null,
    },
    ultimateFeatures: {
      type: Object,
      required: false,
      default: null,
    },
  },
  data() {
    return {
      steps: ['Your people', 'Current time', 'Time savings'],
      currentStep: 0,
      formData: {
        numberOfUsers: 100,
        numberOfMaintainers: 1,
        daysToProduction: null,
        developmentConfigurationHours: null,
        developmentSecurityHours: null,
      },
    };
  },
  computed: {
    allInputsEntered() {
      return (
        this.formData.daysToProduction > 0 &&
        this.formData.developmentConfigurationHours > 0 &&
        this.formData.developmentSecurityHours > 0
      );
    },
  },
};
</script>

<template>
  <article :class="`calculator ${currentStep == 2 && 'showing-results'}`">
    <div class="calculator-container">
      <StepProgress
        :steps="steps"
        :active="currentStep"
        @changeStep="selectStep"
      />
      <div class="form" aria-live="polite" @submit.prevent>
        <div v-show="currentStep == 0">
          <SlpTypography tag="h2" variant="body1-bold">
            {{ timeData.people }}
          </SlpTypography>
          <div class="form-controls">
            <div class="form-control">
              <label for="numberOfUsers"
                >{{ timeData.users }}
                <SlpTooltip
                  id="numberOfUsers"
                  position="top"
                  mode="click"
                  :text="tooltipData.numberOfUsers"
                  class="tooltip"
                >
                  <SlpIcon variant="product" name="information-o" /></SlpTooltip
              ></label>
              <Input
                id="numberOfUsers"
                v-model.number="formData.numberOfUsers"
                min="1"
              />
            </div>
            <div class="form-control line-break">
              <label for="numberOfMaintainers"
                >{{ timeData.maintainers }}
                <SlpTooltip
                  id="numberOfMaintainers"
                  position="top"
                  mode="click"
                  :text="tooltipData.numberOfMaintainers"
                  class="tooltip"
                >
                  <SlpIcon variant="product" name="information-o" /></SlpTooltip
              ></label>
              <Input
                id="numberOfMaintainers"
                v-model.number="formData.numberOfMaintainers"
                min="0"
              />
            </div>
          </div>
          <button
            data-ga-name="continue to next step"
            data-ga-location="roi calculator landing"
            class="slp-btn primary"
            type="button"
            :disabled="
              formData.numberOfMaintainers < 0 || formData.numberOfUsers < 1
            "
            @click="nextStep"
          >
            {{ timeData.nextStep }}
            <SlpIcon variant="product" name="arrow-right" />
          </button>
        </div>
        <div v-show="currentStep == 1">
          <div class="form-controls time-entry">
            <div class="form-control">
              <label for="daysToProduction"
                >{{ timeData.howManyDaysToProduction }}
              </label>
              <div class="input-content">
                <Input
                  id="daysToProduction"
                  v-model.number="formData.daysToProduction"
                  placeholder="45"
                  min="0"
                />
                <SlpTypography tag="p" variant="body2">
                  {{ timeData.daysToProduction }}
                </SlpTypography>
              </div>
            </div>
            <div class="form-control">
              <label for="developmentConfigurationHours"
                >{{ timeData.developmentConfigurationHours }}
              </label>
              <div class="input-content">
                <Input
                  id="developmentConfigurationHours"
                  v-model.number="formData.developmentConfigurationHours"
                  placeholder="5"
                  min="0"
                />
                <SlpTypography tag="p" variant="body2">
                  {{ timeData.hoursPerWeek }}
                </SlpTypography>
              </div>
            </div>
            <div class="form-control">
              <label for="developmentSecurityHours">{{
                timeData.developmentSecurityHours
              }}</label>
              <div class="input-content">
                <Input
                  id="developmentSecurityHours"
                  v-model.number="formData.developmentSecurityHours"
                  placeholder="10"
                  min="0"
                />
                <SlpTypography tag="p" variant="body2">
                  {{ timeData.hoursPerWeek }}
                </SlpTypography>
              </div>
            </div>
          </div>
          <button
            data-ga-name="see your savings"
            data-ga-location="roi calculator spending"
            class="slp-btn primary"
            type="button"
            :disabled="!allInputsEntered"
            @click="nextStep"
          >
            {{ timeData.savings }}
            <SlpIcon variant="product" name="arrow-right" />
          </button>
        </div>
        <TimeResults
          v-show="currentStep == 2"
          :form-data="formData"
          :time-results="timeResultsData"
          :premium-features="premiumFeatures"
          :ultimate-features="ultimateFeatures"
          v-on="$listeners"
        />
      </div>
    </div>
  </article>
</template>

<style lang="scss" scoped>
@import '../../assets/css/roi-calculators.scss';

.calculator-wrapper .tab-wrapper .calculator .form .form-controls.time-entry {
  flex-direction: column;
  margin-bottom: 0;

  .form-control {
    width: 100%;
    display: flex;
    align-items: flex-start;
    flex: 1 0 100%;
    flex-direction: column;
    margin-bottom: $spacing-32;
  }
  label {
    font-size: $text-body-1-bold;
    line-height: $line-height-body-1;
    font-weight: $font-weight-bold;
    flex: 0 0 60%;
    margin-bottom: $spacing-16;
  }

  .input-content {
    display: flex;
    align-items: center;
  }

  .input-content:deep .input-wrapper {
    max-width: 70px;
    margin-right: $spacing-8;
  }

  @media (max-width: $breakpoint-md) {
    .form-control {
      flex-direction: column;
      margin-bottom: $spacing-32;
    }
  }
}
</style>
